<?xml version="1.0" encoding="ISO-8859-1"?>

<rss version="0.91">
  <channel>
    <title>Changes report</title>
    <link>http://jakarta.apache.org/commons/math/</link>
    <description>Changes report</description>
    <language>en-us</language>
    <copyright>Copyright 2004 The Apache Software Foundation</copyright>
    <item>
      <title>34 change(s) for version 1.1</title>
      <link>http://jakarta.apache.org/commons/math//changes-report.html</link>
      <description>
        <table border="1">
          <tr>
            <th style="width:50px">Type</th>
            <th>Changes</th>
            <th style="width:70px">By</th>
          </tr>
          <tr>
            <td>fix</td>
            <td>Made NewtonSolver derivative field transient and implemented readObject to initialize. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36491">36491</a>.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Made sampleStats field private and changed getUpperBounds to return a fresh copy in EmpiricalDistributionImpl. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36491">36491</a>.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>update</td>
            <td>Added polar2Complex method to ComplexUtils to create Complex numbers from polar representations.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Made all serialVersionUIDs private. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=37162">37162</a>. Thanks to Elliotte Harold .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Improved documentation and test cases related to handling of infinite and NaN values in Complex, ComplexUtils classes. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=37086">37086</a>.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Fixed incorrect NaN handling in o.a.m.s.d.rank.Min, Max Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=37019">37019</a>. Thanks to Mauro Talevi .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Changed RealMatrixImpl.equals to use Double.doubleToLongBits to compare corresponding matrix entries. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36491">36491</a>.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Eliminated floating point equals comparison in Percentile.evaluate. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36491">36491</a>.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Eliminated unnecessary assignment statements in Skewness.getResult method. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36491">36491</a>.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Synchronized getters in ResizeableDoubleArray. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36491">36491</a>.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Eliminated unnecessary assignment statement in BisectionSolver.solve method. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36491">36491</a>.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Implemented hashCode in the Complex class and changed the semantics of equals to make all instances with real or imaginary part NaN equal. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36491">36491</a>.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Fixed bin index overflow problem in EmpiricalDistributionImpl. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36450">36450</a>. Thanks to Keith McDonald .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Added protection against numerical overflow and underflow in the isBracketing method. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36232">36232</a>. Thanks to Xiaogang Zhang .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#brentworden">brentworden</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Fixed division by zero error in rounding methods. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36300">36300</a>. Thanks to Nikhil Gupte .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#brentworden">brentworden</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Added upper tail cumulative probability method to HypergeometricDistributionImpl. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36215">36215</a>. Thanks to Mike Hu .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#brentworden">brentworden</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Added better handling of numerical overflow and division by zero in Complex calculations. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36205">36205</a>. Thanks to Xiaogang Zhang .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#brentworden">brentworden</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Changed ContinuedFraction to better handle infinite convergents that resulted in divergent continued fraction evaluations. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=36105">36105</a>. Thanks to Mikael Weigelt .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#brentworden">brentworden</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Changed rounding methods to not rely on BigDecimal conversions which was causing numerical error. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=35904">35904</a>. Thanks to Srinivas Vemury .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#brentworden">brentworden</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Changed Fraction(double) to correctly handle near-integral arguments. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=35434">35434</a>. Thanks to Jörg Weimar .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Changed lcm to throw ArithmeticException (instead of returning bogus value) if the result is too large to store as an integer. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=35431">35431</a>. Thanks to Jörg Weimar .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Added factories for TTest, ChiSquareTest and TestUtils class with static methods to create instances and execute tests. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=32663">32663</a>. Thanks to Mary Ellen Foster .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>update</td>
            <td>Eliminated repeated endpoint function evalutations in BrentSolver, SecantSolver. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=35042">35042</a>. Thanks to Paul Field .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>update</td>
            <td>Added setSubMatrix methods to RealMatrixImpl, BigMatrixImpl. To Preserve backward compatibility with version 1.0, these methods were not added to the RealMatrix, BigMatrix interfaces. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=35007">35007</a>. Thanks to Rodrigo di Lorenzo Lopes .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>update</td>
            <td>Added createXIdentityMatrix methods to MatrixUtils and deprecated getIdentity methods in RealMatrixImpl, BigMatrixImpl. Modified RealMatrixImpl, BigMatrixImpl constructors to throw IllegalArgumentExceptions instead of ArrayIndexOutOfBounds when dimension arguments are not positive.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>update</td>
            <td>Made PRNG pluggable for classes in the random package. Added RandomGenerator interface extracted from java.util.random and abstract implementation, AbstractRandomGenerator providing default implementations of methods based on nextDouble(). Added a constructor taking a RandomGenerator as an argument to RandomDataImpl. Changed ValueServer to use a RandomData in its constructor. Changes to 1.0 classes should be backward compatible (including serialization).</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>update</td>
            <td>Added utility methods for overflow-checked integer arithmetic and improved gcd method in MathUtils. Thanks to C. Scott Ananian .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Fixed error in TTestImpl.homoscedasticTtest. Implementation was incorrectly using heteroscedastic t statistic. Also improved sensitivity of test cases. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=34677">34677</a>. Thanks to Gilles Gaillard .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Fixed javadoc errors. One-sided t-test significance adjustment was reversed in javadoc for boolean-valued test methods. Fixes
              <a href="http://issues.apache.org/bugzilla/show_bug.cgi?id=34448">34448</a>. Thanks to Gilles Gaillard .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#psteitz">psteitz</a>
            </td>
          </tr>
          <tr>
            <td>fix</td>
            <td>Fixed bug in PolynomialSplineFunction to allow evaluation of the function at the last knot point. Thanks to Ben Litchfield .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#brentworden">brentworden</a>
            </td>
          </tr>
          <tr>
            <td>add</td>
            <td>Added Weibull distribution implementation.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#brentworden">brentworden</a>
            </td>
          </tr>
          <tr>
            <td>add</td>
            <td>Added Cauchy distribution implementation.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#brentworden">brentworden</a>
            </td>
          </tr>
          <tr>
            <td>add</td>
            <td>Added convenience methods for rounding.</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#brentworden">brentworden</a>
            </td>
          </tr>
          <tr>
            <td>add</td>
            <td>Added Fraction class based on commons-lang implementation. With the fraction class, FractionFormat and ProperFractionFormat classes were added to provide fraction formatting and parsing. Thanks to C. Scott Ananian .</td>
            <td>
              <a href="http://jakarta.apache.org/commons/math//team-list.html#brentworden">brentworden</a>
            </td>
          </tr>
        </table>
      </description>
    </item>
  </channel>
</rss>